Index: trunk/LMDZ.COMMON/libf/dyn3d/abort_gcm.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3d/abort_gcm.F	(revision 3349)
+++ trunk/LMDZ.COMMON/libf/dyn3d/abort_gcm.F	(revision 3350)
@@ -51,8 +51,8 @@
       write(lunout,*) 'Reason = ',message
       if (ierr .eq. 0) then
-        write(lunout,*) 'Everything is cool'
+        write(lunout,*) 'Everything is cool!'
         stop
       else
-        write(lunout,*) 'Houston, we have a problem ', ierr
+        write(lunout,*) 'Houston, we have a problem, ierr =', ierr
         stop 1
       endif
Index: trunk/LMDZ.COMMON/libf/dyn3dpar/abort_gcm.F
===================================================================
--- trunk/LMDZ.COMMON/libf/dyn3dpar/abort_gcm.F	(revision 3349)
+++ trunk/LMDZ.COMMON/libf/dyn3dpar/abort_gcm.F	(revision 3350)
@@ -51,7 +51,7 @@
       write(lunout,*) 'Reason = ',message
       if (ierr .eq. 0) then
-        write(lunout,*) 'Everything is cool'
+        write(lunout,*) 'Everything is cool!'
       else
-        write(lunout,*) 'Houston, we have a problem, ierr = ', ierr
+        write(lunout,*) 'Houston, we have a problem, ierr =', ierr
 #ifdef CPP_MPI
 C$OMP CRITICAL (MPI_ABORT_GCM)
Index: trunk/LMDZ.COMMON/libf/phy_common/abort_physic.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/phy_common/abort_physic.F90	(revision 3349)
+++ trunk/LMDZ.COMMON/libf/phy_common/abort_physic.F90	(revision 3350)
@@ -37,7 +37,7 @@
       write(lunout,*) 'Reason = ',message
       if (ierr .eq. 0) then
-        write(lunout,*) 'Everything is cool'
+        write(lunout,*) 'Everything is cool!'
       else
-        write(lunout,*) 'Houston, we have a problem, ierr = ', ierr
+        write(lunout,*) 'Houston, we have a problem, ierr =', ierr
 #ifdef CPP_MPI
 !$OMP CRITICAL (MPI_ABORT_PHYSIC)
Index: trunk/LMDZ.MARS/changelog.txt
===================================================================
--- trunk/LMDZ.MARS/changelog.txt	(revision 3349)
+++ trunk/LMDZ.MARS/changelog.txt	(revision 3350)
@@ -4660,2 +4660,6 @@
 Following commit r3337, threshold for vdifc subtimestep is no longer hardcoded
 and explicitly commented.
+
+== 31/05/2024 == JBC
+- Correction for the script "launch_orb_1Dchained.sh" in the deftank.
+- Small cleanings related to error detection.
Index: trunk/LMDZ.MARS/deftank/launch_orb_1Dchained.sh
===================================================================
--- trunk/LMDZ.MARS/deftank/launch_orb_1Dchained.sh	(revision 3349)
+++ trunk/LMDZ.MARS/deftank/launch_orb_1Dchained.sh	(revision 3350)
@@ -88,5 +88,5 @@
 while [ $i_myear -lt $n_myears ]; do
     # Get the new values for the orbital parameters
-    yearlask=$(echo "$eyears_bp_ini + $i_myear*$convert_years" | bc -l)
+    yearlask=$(echo "($eyears_bp_ini + $i_myear*$convert_years)/1000." | bc -l)
     found=false
     read -r y1 obl1 ecc1 lsp1 < "$orb_data"
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F90	(revision 3349)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/testphys1d.F90	(revision 3350)
@@ -268,5 +268,5 @@
 if (startfiles_1D) call writerestart1D('restart1D.txt',psurf,tsurf(1,:),nlayer,size(tsurf,2),temp,u,v,nq,noms,qsurf(1,:,:),q)
 
-write(*,*) "testphys1d: everything is cool."
+write(*,*) "testphys1d: everything is cool!"
 
 END PROGRAM testphys1d
Index: trunk/LMDZ.MARS/libf/phymars/phyetat0_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/phyetat0_mod.F90	(revision 3349)
+++ trunk/LMDZ.MARS/libf/phymars/phyetat0_mod.F90	(revision 3350)
@@ -840,8 +840,5 @@
         write(*,*) "phyetat0: Failed loading <perennial_co2ice> : ", &
                    "<perennial_co2ice> is set as 10m at the South Pole"
-        if (abs(latitude(ngrid) - (-pi/2.)) < 1.e-5) then
-            perennial_co2ice(ngrid,:) = 10*1.6e3 ! 10m which is convert to kg/m^2
-            qsurf(ngrid,igcm_co2_tmp,:) = qsurf(ngrid - 1,igcm_co2_tmp,:) 
-        endif
+        if (abs(latitude(ngrid) - (-pi/2.)) < 1.e-5) perennial_co2ice(ngrid,:) = 10*1.6e3 ! 10m which is convert to kg/m^2
     endif ! not found
   else ! no startfiphyle
@@ -850,8 +847,5 @@
     d_coef = 4.e-4
     perennial_co2ice = 0.
-    if (abs(latitude(ngrid) - (-pi/2.)) < 1.e-5) then
-        perennial_co2ice(ngrid,:) = 10*1.6e3 ! 10m which is convert to kg/m^2
-        qsurf(ngrid,igcm_co2_tmp,:) = qsurf(ngrid - 1,igcm_co2_tmp,:)
-    endif
+    if (abs(latitude(ngrid) - (-pi/2.)) < 1.e-5) perennial_co2ice(ngrid,:) = 10*1.6e3 ! 10m which is convert to kg/m^2
   endif !startphy_file
 else