Index: trunk/LMDZ.MARS/changelog.txt
===================================================================
--- trunk/LMDZ.MARS/changelog.txt	(revision 3384)
+++ trunk/LMDZ.MARS/changelog.txt	(revision 3385)
@@ -4671,2 +4671,5 @@
 This should makes things (hopefully) clearer for users and also better
 enforces a cleaner and clearer separation between dynamics and physics.
+
+== 19/06/2024 == JBC
+Update of the "run.def.1d" file in the deftank.
Index: trunk/LMDZ.MARS/deftank/run.def.1d
===================================================================
--- trunk/LMDZ.MARS/deftank/run.def.1d	(revision 3384)
+++ trunk/LMDZ.MARS/deftank/run.def.1d	(revision 3385)
@@ -3,4 +3,11 @@
 # Run parameters for the 1D 'testphys1d.e' model                                          
 #-----------------------------------------------------------------------                                         
+
+#### In/Output parameters
+#
+# Initialization with start files if they are present and writing of restart files
+startfiles_1D=.false.
+# Writing subsurface outputs
+diagsoil=.false.
 
 #### Time integration parameters
@@ -9,18 +16,18 @@
 day0=0
 # Initial local time (in hours, between 0 and 24)
-time=0
+time=0.
 # Number of time steps per sol
 day_step=48
 # Number of sols to run 
-ndt = 100
+ndt = 669
 
 #### Physical parameters
 #
 # Surface pressure (Pa)
-psurf= 610
+psurf=610.
 # Reference dust opacity at 610 Pa, in the visible (true tau~tauref*psurf/610)
 tauvis=0.2
 # latitude (in degrees)
-latitude= 0.
+latitude=0.
 # Albedo of bare ground
 albedo=0.2
@@ -32,5 +39,5 @@
 v=0.
 # Initial CO2 ice on the surface (kg.m-2)
-co2ice=0
+co2ice=0.
 # Water ice cap on ground ?
 watercaptag=.false.
@@ -38,8 +45,8 @@
 # (for slope insolation scheme, when callslope=.true. in callphys.def)
 # slope_inclination angle (deg) 0: horizontal, 90: vertical
-slope_inclination=20.0
+slope_inclination=0.
 # slope orientation (deg)
 # 0 == Northward, 90 == Eastward, 180 == Southward, 270 == Westward
-slope_orientation=90.0
+slope_orientation=0.
 
 # hybrid vertical coordinate ? (.true. for hybrid and .false. for sigma levels)
Index: trunk/LMDZ.MARS/libf/phymars/dyn1d/init_testphys1d_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/dyn1d/init_testphys1d_mod.F90	(revision 3384)
+++ trunk/LMDZ.MARS/libf/phymars/dyn1d/init_testphys1d_mod.F90	(revision 3385)
@@ -5,5 +5,5 @@
 contains
 
-SUBROUTINE init_testphys1d(start1Dname,startfiname,therestart1D,therestartfi,ngrid,nlayer,odpref, &
+SUBROUTINE init_testphys1d(start1Dname,startfiname,therestart1D,therestartfi,ngrid,nlayer,odpref,               &
                            nq,q,time,psurf,u,v,temp,ndt,ptif,pks,dttestphys,zqsat,dq,dqdyn,day0,day,gru,grv,w,  &
                            play,plev,latitude,longitude,cell_area,atm_wat_profile,atm_wat_tau)
@@ -11,5 +11,5 @@
 use ioipsl_getincom,          only: getin ! To use 'getin'
 use comcstfi_h,               only: pi, rad, omeg, g, mugaz, rcp, r, cpp
-use time_phylmdz_mod, only: daysec, steps_per_sol, outputs_per_sol, iphysiq
+use time_phylmdz_mod,         only: daysec, steps_per_sol, outputs_per_sol, iphysiq
 use planete_h,                only: year_day, periheli, aphelie, peri_day, obliquit, emin_turb, lmixmin
 use surfdat_h,                only: albedodat, z0_default, z0, emissiv, emisice, albedice, iceradius, dtemisice,      &
@@ -21,5 +21,5 @@
 use physics_distribution_mod, only: init_physics_distribution
 use comsoil_h,                only: volcapa, nsoilmx, inertiesoil, inertiedat, layer, mlayer, flux_geo, tsoil, &
-                                    adsorption_soil, qsoil, igcm_h2o_ice_soil, porosity_reg, &
+                                    adsorption_soil, qsoil, igcm_h2o_ice_soil, porosity_reg,                   &
                                     ini_comsoil_h_slope_var, end_comsoil_h_slope_var, ads_massive_ice
 use comvert_mod,              only: ap, bp, aps, bps, pa, preff, presnivs, pseudoalt, scaleheight